#!/usr/bin/python
from socket import socketpair, MSG_WAITALL
from sys import argv, exit
from struct import pack, unpack
from time import time
from threading import Thread

n = 0 

try:
    n = int(argv[1])
except:
    print "usage: python",argv[0],"<number>"
    exit(1)

print "benchmarking socket connection now."

pair = socketpair()
serversocket = pair[0]
clientsocket = pair[1]


def writeloop(r):
    serversocket.send(pack("!i",255)) #bootstrap, send any int... (255 in this case)
    for i in range(0,r):
        serversocket.send(pack("!i",unpack("!i",serversocket.recv(4,MSG_WAITALL))[0]))
        
def readloop(r):
    results = []
    for i in range(0,r):
        results.insert(0,unpack("!i",clientsocket.recv(4, MSG_WAITALL))[0])
        clientsocket.send(pack("!i",results[0]))


starttime = time()

t = Thread(None, lambda:writeloop(n))
t.start()
readloop(n)

print "time needed for",n,"iterations:",time()-starttime,"seconds"
print "done"
